// StartupTip.cpp : implementation file
//

#include "stdafx.h"
#include "StartupTip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CStartupTip

CStartupTip::CStartupTip()
{
	myicon=NULL;
	myicon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	bgColor=RGB(255,255,255);
	LeftPane=50;
	LeftPaneColor=RGB(132,130,132);
	vspace=30;
	vsize=3;
	nTipLen=50;

	for(int i=0;i<10;i++) memset(&Tips[i].Text[0],0,100);
}

CStartupTip::~CStartupTip()
{
}


BEGIN_MESSAGE_MAP(CStartupTip, CStatic)
	//{{AFX_MSG_MAP(CStartupTip)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStartupTip message handlers

void CStartupTip::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	// Draw LeftPane
	RECT rc;
	GetClientRect(&rc);
	rc.right=LeftPane;
	dc.FillSolidRect(&rc,LeftPaneColor);

	// Draw icon in LeftPane
	if (myicon!=NULL)
		DrawIcon(dc.m_hDC,(LeftPane/2)-16,6,myicon);

	// Draw horizontal line in RightPane
	GetClientRect(&rc);
	rc.left=LeftPane;
	rc.top=vspace;
	rc.bottom=vsize+vspace;
	dc.FillSolidRect(&rc,LeftPaneColor);

	// Draw text "Did you know..." in the top of RightPane
	dc.SetBkColor(bgColor);
	CFont aFont;
	aFont.CreateFont(22,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,0,0,DEFAULT_QUALITY,FF_ROMAN,"Times New Roman");
	CFont * OldFontPtr=dc.SelectObject(&aFont);
	dc.TextOut(LeftPane+5,5,"Did you know...");

	CFont bFont;
	bFont.CreateFont(16,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,0,0,DEFAULT_QUALITY,DEFAULT_PITCH|FF_SWISS,"Arial");
	dc.SelectObject(&bFont);

	GetClientRect(&rc);
	rc.right=rc.right-5;

	int i,j;

	for(i=0;i<nLines;i++)
	{
		j=strlen(&Tips[i].Text[0]);
		if (j==0) continue;
		dc.ExtTextOut(LeftPane+5,vsize+vspace+5+16*i,ETO_CLIPPED,
			&rc,&Tips[i].Text[0],j,NULL);
	};

	dc.SelectObject(OldFontPtr);
	// Do not call CStatic::OnPaint() for painting messages
}

BOOL CStartupTip::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	RECT rc;
	GetClientRect(&rc);
	pDC->FillSolidRect(&rc,bgColor);

	return 0;
	return CStatic::OnEraseBkgnd(pDC);
}

void CStartupTip::SetBgColor(COLORREF color)
{
	bgColor=color;
}

void CStartupTip::SetLeftPaneSize(int c)
{
	LeftPane=c;
}

void CStartupTip::SetLeftPaneColor(COLORREF color)
{
	LeftPaneColor=color;	
}

void CStartupTip::SetIcon(UINT n)
{
	nIconId=n;
	myicon=AfxGetApp()->LoadIcon(nIconId);
	Invalidate(TRUE);
}

void CStartupTip::SetTipText(LPCTSTR lpText)
{
	nLines=0;

	int i,j,k,u,p;
	CString str,str2;
	char szWord[100];

	for(i=0;i<10;i++) memset(&Tips[i].Text[0],0,100);

	str=lpText;
	memset(szWord,0,100);

	i=GetWord((LPCTSTR)str,&szWord[0]);
	u=0;  // letter counter in string
	p=0;  // string counter
	while (i>0)
	{
		k=strlen(&szWord[0]);
		u=u+k+1;
		if (u<nTipLen)
		{
			strcat(&Tips[p].Text[0],&szWord[0]);
			strcat(&Tips[p].Text[0]," ");
		}
		else
		{
			if (p<9)
			{
				p++;
				u=k+1;
				strcat(&Tips[p].Text[0],&szWord[0]);
				strcat(&Tips[p].Text[0]," ");
			};
		};

		j=str.GetLength();
		str=str.Right(j-i);
		memset(szWord,0,100);
		i=GetWord((LPCTSTR)str,&szWord[0]);
	};

	if (u>0) nLines=p+1;

	Invalidate(TRUE);
}


int CStartupTip::GetWord(LPCTSTR in_str, LPTSTR lpWord)
{
	int i=0;
	int j=0;
	LPCTSTR lpStr;

	lpStr=in_str;

	// detect leading spaces
	while ((*lpStr==' '))
	{
		i++;
		lpStr++;
	};
	if (*lpStr=='\0') return 0;

	// copy symbols to word buffer until space or EOL
	while ((*lpStr!=' ') && (*lpStr!='\0'))
	{
		lpWord[j]=*lpStr;
		j++;
		i++;
		lpStr++;
	};

	return i;
}

void CStartupTip::SetMaxLen(int n)
{
	if (n<1) return;

	if (n>100)
		nTipLen=100;
	else
		nTipLen=n;
}
